/* COMP 211, Fall 2021
 * Homework 10
 *
 * Graphs, trees, and searching
 */

#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>

#include "hw10.h"

struct menu_opt {
    char* desc;
    void (*act)(void);
};

struct graph *g = NULL;
int num_nodes;

void do_exit() { exit(0); }

void do_make_empty() {
    printf("Enter number of nodes: ");
    scanf(" %d", &num_nodes);
    g = graph_create(num_nodes);
};

void do_add_edge() {
    int x, y;
    printf("Enter first node id: ");
    scanf(" %d", &x);
    printf("Enter second node id: ");
    scanf(" %d", &y);
    graph_add(g, x, y);
}

void do_delete_edge() {
    int x, y;
    printf("Enter first node id: ");
    scanf(" %d", &x);
    printf("Enter second node id: ");
    scanf(" %d", &y);
    graph_del(g, x, y);
};

void do_dfs() {
    int* visited = graph_dfs(g, 0);
    for (int i=0; i<num_nodes; i++) {
        printf("visited[%d]: %d\n", i, visited[i]);
    }
};

void do_connected() {
    bool b = graph_connected(g);
    printf("Graph is connected? %d\n", b);
};

void do_print() {
    graph_print(g);
};

int main(int argc, char **argv) {

    struct menu_opt menu[] = {
        {"Exit", do_exit},
        {"Create empty graph", do_make_empty},
        {"Add edge", do_add_edge},
        {"Delete edge", do_delete_edge},
        {"Do DFS", do_dfs},
        {"Check connected", do_connected},
        {"Print adjacency lists", do_print}
    };

    // WARNING:  this method for computing the size of an array only works when
    // the array is declared on the stack.  In particular, it is not valid when
    // the array is allocated using malloc, calloc, etc.
    int n_menu = sizeof(menu)/sizeof(struct menu_opt);

    int choice;

    while (true) {
        for (int i=0; i<n_menu; ++i) {
            printf("(%d) %s\n", i, menu[i].desc);
        }
        printf("Enter choice: ");
        scanf("%u", &choice);
        menu[choice].act();
    }

    return 0;
}
