/* COMP 211, Fall 2021
 * Homework 10
 *
 * Graphs, trees, and searching
 */

#include "list.h"

typedef struct graph {
    list **A; // array of lists
    int N; // number of nodes
} graph;

/*
 * Initializes graph structure
 */
graph* graph_create(int);

/*
 * Adds a bidirectional edge to graph:
 * i.e., adds <x,y> and <y,x> to adjacency lists
 */
void graph_add(graph*, int x, int y);
/*
 * Removes a bidirectional edge to graph:
 * i.e., removes <x,y> and <y,x> from adjacency lists
 */
void graph_del(graph*, int x, int y);

/* Performs a depth-first search starting from the given
 * node on the the given graph. Returns the visited array
 */
int* graph_dfs(graph*, int);

/* Uses the dfs function to check whether the graph is connected.
 */
bool graph_connected(graph*);

/* Print adjacency lists of graph
 */
void graph_print(graph*);
