/* COMP 211, Fall 2021
 *
 * Singly linked list with dummy head node
 */

#include <stdio.h>
#include <stdlib.h>

#include "list.h"

list* list_create()
{
    // Create dummy head node
    node *n = malloc(sizeof(node));
    n->next = NULL;

    // Add dummy head node to head of list
    list* l = malloc(sizeof(list));
    l->head = n;
    return l;
}

bool list_empty(list *l)
{
    if (l->head->next == NULL) {
        return true;
    }
    return false;
}

void list_add(list *l, item data)
{
    // Check whether node in list already
    node *temp = l->head;
    while (temp->next != NULL) {
        if (temp->next->data == data) return;
        temp = temp->next;
    }

    // Add node
    node *n = malloc(sizeof(node));
    n->data = data;
    n->next = NULL;
    temp->next = n;
}

void list_del(list *l, item data)
{
    node *temp = l->head;
    while (temp->next != NULL) {
        if (temp->next->data == data) {
            node *del = temp->next;
            temp->next = del->next;
            free(del);
            return;
        }
        temp = temp->next;
    }
}

bool list_search(list *l, item data)
{
    node *temp = l->head;
    while (temp->next != NULL) {
        if (temp->next->data == data) {
            return true;
        }
        temp = temp->next;
    }
    return false;
}

int list_size(list *l)
{
    int i = 0;
    node *temp = l->head->next;
    while (temp != NULL) {
        temp = temp->next;
        i++;
    }
    return i;
}

void list_print(list *l)
{
    node *node = l->head->next;
    while (node != NULL) {
        printf("%d ", node->data);
        node = node->next;
    }
    printf("\n");
}
