/* COMP 211, Fall 2021
 *
 * Stack implementation
 */

#include <stdio.h>
#include <stdlib.h>

#include "stack.h"

stack* stack_new(int size)
{
    stack *s = malloc(sizeof(stack));
    s->data = malloc(sizeof(int) * size);
    s->top = 0;
    s->max = size;
    return s;
}

bool stack_empty(stack *s)
{
    if (s->top == 0) {
        return true;
    }
    return false;
}

bool stack_full(stack *s)
{
    if (s->top == s->max) {
        return true;
    }
    return false;
}

void stack_push(stack *s, int data)
{
    if (stack_full(s)) return;
    s->data[s->top] = data;
    s->top = s->top + 1;
}

int stack_pop(stack *s)
{
    if (stack_empty(s)) return -1;
    int data = s->data[s->top-1];
    s->top = s->top-1;
    return data;
}

int stack_top(stack *s)
{
    if (stack_empty(s)) return -1;
    return s->data[s->top-1];
}

void stack_print(stack *s)
{
    printf("%s: Stack contents: \n", __FUNCTION__);
    for (int i=s->top-1; i>=0; i--) {
        printf("Stack[%d] = %d \n", i, s->data[i]);
    }
    printf("\n");
}
